# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Convert a matrix to a vector of arrays
#'
#' @param x object to be converted
#'
#' @details The algorithms in kdtools can accept either matrices or an
#' \link{arrayvec} object. When a matrix is passed, it is converted to
#' an arrayvec object internally and the results are converted back to
#' a matrix. For optimal performance, pre-convert matrices.
#'
#' @examples
#' x = matrix(1:10, 5)
#' y = matrix_to_tuples(x)
#' str(x)
#' str(y)
#' y[1:2, ]
#'
#' @rdname convert
#' @export
matrix_to_tuples <- function(x) {
    .Call(`_kdtools_matrix_to_tuples`, x)
}

#' @rdname convert
#' @export
tuples_to_matrix <- function(x) {
    .Call(`_kdtools_tuples_to_matrix`, x)
}

tuples_to_matrix_rows <- function(x, a, b) {
    .Call(`_kdtools_tuples_to_matrix_rows`, x, a, b)
}

kd_sort_ <- function(x, inplace = FALSE, parallel = FALSE) {
    .Call(`_kdtools_kd_sort_`, x, inplace, parallel)
}

kd_is_sorted_ <- function(x) {
    .Call(`_kdtools_kd_is_sorted_`, x)
}

lex_sort_ <- function(x, inplace = FALSE) {
    .Call(`_kdtools_lex_sort_`, x, inplace)
}

kd_lower_bound_ <- function(x, value) {
    .Call(`_kdtools_kd_lower_bound_`, x, value)
}

kd_upper_bound_ <- function(x, value) {
    .Call(`_kdtools_kd_upper_bound_`, x, value)
}

kd_range_query_ <- function(x, lower, upper) {
    .Call(`_kdtools_kd_range_query_`, x, lower, upper)
}

kd_nearest_neighbor_ <- function(x, value) {
    .Call(`_kdtools_kd_nearest_neighbor_`, x, value)
}

kd_binary_search_ <- function(x, value) {
    .Call(`_kdtools_kd_binary_search_`, x, value)
}

kd_nearest_neighbors_ <- function(x, value, n) {
    .Call(`_kdtools_kd_nearest_neighbors_`, x, value, n)
}

